#!/usr/bin/perl

use IO::Socket::INET;
use Time::HiRes qw(gettimeofday);
use MIME::Base64 qw( encode_base64 decode_base64 );


sendData_flush("130.92.66.131", 4000, "lst");


sub sendData_flush {
    my $DESTINATION_IP   = $_[0];
    my $DESTINATION_PORT = $_[1];
    my $text             = $_[2];

    my $sock = new IO::Socket::INET(PeerAddr=>$DESTINATION_IP,PeerPort=>$DESTINATION_PORT,Proto=>'tcp');
    if($sock) {
        $sock->send($text);
        $sock->close();
        return 1;
    }
    else {
        print "could not send data, destination $DESTINATION_IP:$DESTINATION_PORT not reachable\n";
        return 0;
    }
}