<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
include 'expSetupMenue.php';
?>
</div> <!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>    
  <?php
	  require_once("../include/classes.inc.php");
	  require_once("../include/functions.php");
	  //select DB
	  Db::getInstance($config)->selectDB();
	?>


<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='expSetupUploadInfoBox' class='infoBox'>
  <!-- Information text about the images (name, version, platform, description, file, etc) -->
  <div id='expSetupUploadInfoText' class='infoText'>
  <?php
    if(checkAccessRights($_SERVER['personUniqueID'], "createExperiment"))
    {
      echo "<p><strong>My Image:</strong> The user can upload a new message or update, delete or download an exisiting image. Please fill the form with the <strong>name</strong> of the image, its <strong>version</strong>, the <strong>platform</strong> which can be flashed with the image, and a short <strong>description</strong> about the image.</p>";
    }
    else
    {
      echo "<p><font color='#FF000'>" . "<strong>Error:</strong> You are not allowed to create experiments on the testbed!" . "</font></p>";
      exit;
    }
  ?>
  </div>
  <div id='expSetupUploadCrossLine' class='crossLine'>
    &nbsp;
  </div>

</div> <!-- end div container 'infoBox' -->
<!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='expSetupUploadContentBox' class='contentBox'>
  <?php

    if(!empty($_POST) && $_POST['sub'] != "")
    {
      $dbInsertArray = array();
      $dbInsertArray['img_id']            = $_POST['id'];
      $dbInsertArray['img_name']          = $_POST['name'];
      $dbInsertArray['img_version']       = $_POST['version'];
      $dbInsertArray['img_platform']      = $_POST['platform'];
      $dbInsertArray['img_description']   = $_POST['description'];
      $dbInsertArray['img_file_name']     = ($_FILES['imageFile']['name']);
      $imageTmpFile                       = ($_FILES['imageFile']['tmp_name']);
      $dbInsertArray['img_file_size']     = ($_FILES['imageFile']['size']);
      $dbInsertArray['img_file']          = mysql_real_escape_string(@fread(fopen($imageTmpFile, "r"), filesize($imageTmpFile)));
      //$dbInsertArray['img_file_datetime'] = date("Y-m-d H:i:s");
      $dbInsertArray['img_file_datetime'] = gmdate("Y-m-d H:i:s", time());
      $dbInsertArray['img_file_usecs']    = 0;
      $dbInsertArray['exp_user_unique_id']= $_SERVER['personUniqueID'];
      
      $line = exec("hexdump ". $imageTmpFile . " | head -n 1");
      $line = substr($line, 0, 12);
      if( $line  == "0000000 5a4d" | $line == "0000000 457f" ) {
            echo "<br/>";
            echo "<font color='#FF0000'>";
            if($line  == "0000000 5a4d"){
                echo "The uploaded image looks like a <strong>windows executable</strong> file<br/>";
            }
            else {
                echo "The uploaded image looks like a <strong>linux executable</strong> file<br/>";
            }
            echo "It is <strong>unlikely to run</strong> on most sensor nodes<br/>";
            echo "<strong>Update the image</strong> in case you uploaded the <strong>wrong image</strong><br/>";
            echo "</font>";
            echo "<br/>";
      }
      
      
      
      // calls DB functions according to the pressed button ['sub']
      if($_POST['sub'] == "Upload New Image")
      {
        $imageID = Db::getInstance($config)->addNewImage($dbInsertArray);
      }
      else if($_POST['sub'] == "Update Image")
      {
        $imgID = Db::getInstance($config)->updateImage($dbInsertArray);
      }
      else if($_POST['sub'] == "Delete Image")
      {
        $res = Db::getInstance($config)->deleteImage($dbInsertArray);
        $imageID = 0;
      }
    }
    
    echo "<form enctype='multipart/form-data' name='imageConfForm' action='' method='POST'>";
      $imageArray = array();    //imageArray is used to fill the drop down menue with the avail images
      //first line ist for adding a new image
      $addLine = array('image_id' => 0, 'image_name' => 'Upload New Image', 'image_file_name' => '...');
      array_push($imageArray, $addLine);
      
      Db::getInstance($config)->selectDB();
  
      $imageQueryString = "SELECT image_id, image_name, image_file_name, exp_user_unique_id FROM images WHERE image_visible='1';";
      $res = mysql_query($imageQueryString);
      while ($line = mysql_fetch_assoc($res))
      {
        if(strcmp($line['exp_user_unique_id'], $_SERVER['personUniqueID']) == 0)   //only the own images
        {
          array_push($imageArray, $line);
        }
      }
      
      //table to arrange the formular
      echo "<table border='0'>";    
      echo "<tr><td width='150px'>Available Images:</td>";
      echo "<td width='300px'><select name='imageSel' onChange='Javascript:imageConfForm.submit()'>";
    
      //which was the last seleteced image in the drop down menue
      if(!empty($_POST) && $imageID == "")
      {
        $tmp = split(",", $_POST['imageSel']);
        $imageID = $tmp[0];
      }    
    
      //filling the drop down menue with the available images
      foreach($imageArray as $val)
      {      
        if(!empty($_POST) && $imageID == $val['image_id'])
        {
          echo "<option selected value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . " (" . $val['image_file_name'] . ")" . "</option>";
        }
        else
        {
          echo "<option value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . " (" . $val['image_file_name'] . ")" . "</option>";
        }
      }
      echo "</select></td></tr></table>";
    
      // if an image was selected
      if(!empty($_POST))
      {
        if($imageID != 0) //if an image is selected from the drop down menue
        {
          $selectedImageQueryString = "SELECT image_id, image_name, image_version, image_platform, image_description, image_file_name, image_file_size, image_time, image_usecs FROM images WHERE image_id ='" . $imageID . "';";
          $res2 = mysql_query($selectedImageQueryString);
          $selectedImage = mysql_fetch_assoc($res2);
        }
        //table to arrange the formular
        echo "<table border='0'>";
        echo "<tr><td width='150px'>ID:</td>";
        echo "<td width='300px'><input type='text' name='id' value='" . $selectedImage['image_id'] . "' READONLY style='background-color: grey'></td></tr>";
        echo "<tr><td width='150px'>Name:</td>";        
        echo "<td width='300px'><input type='text' name='name' value='" . $selectedImage['image_name'] . "'></td></tr>";
        echo "<tr><td width='150px'>Version:</td>";        
        echo "<td width='300px'><input type='text' name = 'version' value='" . $selectedImage['image_version'] . "'></td></tr>";
        echo "<tr><td width='150px'>Platform:</td>";        
        echo "<td width='300px'><input type='text' name = 'platform' value='" . $selectedImage['image_platform'] . "'></td></tr>";
        echo "<tr><td width='150px' valign='top'>Description:</td>";        
        echo "<td width='300px'><textarea name='description' cols='50' rows='5'>" . $selectedImage['image_description'] . "</textarea><br/></td></tr>";
        echo "<tr><td width='150px'>File Name:</td>";        
        echo "<td width='300px'><input type='text' name='filename' value='" . $selectedImage['image_file_name'] . "' READONLY style='background-color: grey'></td></tr>";
        echo "<tr><td width='150px'>File Size:</td>";        
        echo "<td width='300px'><input type='text' name='filesize' value='" . $selectedImage['image_file_size'] . "' READONLY style='background-color: grey'></td></tr>";
        echo "<tr><td width='150px'>Time:</td>";        
        echo "<td width='300px'><input type='text' name='time' value='" . $selectedImage['image_time'] . "' READONLY style='background-color: grey'></td></tr>";
        echo "<tr><td width='150px'>File:</td>";                
        echo "<td width='300px'><input type='file' name='imageFile' value ='lalala'></td></tr></table>";
        if($imageID != 0) //if an image is selected from the drop down menue
        {
          echo "<input type='submit' name='sub' value='Update Image'>";
          echo "<input type='submit' name='sub' value='Delete Image'>";
          echo "</form>";
          echo "<form enctype='multipart/form-data' name='imageDownloadForm' action='expSetupDownload.php' method='POST'>";
          echo "<input name='img_id' type='hidden' value='" . $selectedImage['image_id'] . "'>";
          echo "<input type='submit' name='sub' value='Download Image'>";
          echo "</form>";
        }
        else              //if new image should be uploaded (imageID == 0)
        {
          echo "<input type='submit' name='sub' value='Upload New Image'>";
          echo "</form>";
        } 
      }
      else // if $_POST array is empty (at first click, nothing is selected)
      {
        //table to arrange the formular
        echo "<table border='0'>";    
        echo "<tr><td width='150px'>ID:</td>";
        echo "<td width='300px'><input type='text' name='id' value='" . $selectedImage['image_id'] . "' disabled='disabled' style='background-color: grey'></input></td></tr>";
        echo "<tr><td width='150px'>Name:</td>";        
        echo "<td width='300px'><input type='text' name='name' value='" . $selectedImage['image_name'] . "'></input></td></tr>";
        echo "<tr><td width='150px'>Version:</td>";        
        echo "<td width='300px'><input type='text' name = 'version' value='" . $selectedImage['image_version'] . "'></input></td></tr>";
        echo "<tr><td width='150px'>Platform:</td>";        
        echo "<td width='300px'><input type='text' name = 'platform' value='" . $selectedImage['image_platform'] . "'></input></td></tr>";
        echo "<tr><td width='150px' valign='top'>Description:</td>";        
        echo "<td width='300px'><textarea name='description' cols='50' rows='5'>" . $selectedImage['image_description'] . "</textarea></td></tr>";
        echo "<tr><td width='150px'>File Name:</td>";        
        echo "<td width='300px'><input type='text' name='filename' value='" . $selectedImage['image_file_name'] . "' disabled='disabled' style='background-color: grey'></input></td></tr>";
        echo "<tr><td width='150px'>File Size:</td>";        
        echo "<td width='300px'><input type='text' name='filesize' value='" . $selectedImage['image_file_size'] . "' disabled='disabled' style='background-color: grey'></input></td></tr>";
        echo "<tr><td width='150px'>Time:</td>";        
        echo "<td width='300px'><input type='text' name='time' value='" . $selectedImage['image_time'] . "' disabled='disabled' style='background-color: grey'></input></td></tr>";
        echo "<tr><td width='150px'>File:</td>";                
        echo "<td width='300px'><input type='file' name='imageFile'></input></td></tr></table>";
        echo "<input type='submit' name='sub' value='Upload New Image'></input>";   
        echo "</form>"; 
      }    
  ?> 
</div> <!-- end div container 'contentBox' -->
<!-- ********************************************************************** -->


</div> <!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->
