<?php
class CurrExperiment
{
  public $expID;
  public $expName;
  public $expDescription;
  public $network = array();
  public $userGroup;
  public $startTime;
  public $endTime;
  public $visibility;
  public $expControlOutput;
  public $expUserEmail;
  public $lines_gui;
  public $expRuns;
  
  //***************************************************************************
  
  public function __construct($expidparam)
  { 
  	global $config;
  	$this->lines_gui = $config['UPDATE_LINES_TARWIS_GUI'];
  	
    Db::getInstance()->selectDB();
    
    //get the information about the current running experiment
    $query = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_visibility, exp_user_email, exp_runs FROM experiment_info WHERE exp_id='" . $expidparam ."'";
    $result = mysql_query($query)
      or die("Request for experiment_info failed: " . mysql_error());
    $line = mysql_fetch_assoc($result);
    $this->expID = $line['exp_id'];
    $this->network = new Network("Exp" . $line['exp_id'] . "Net");
    $this->expName = $line['exp_name'];
    $this->expDescription = $line['exp_description'];
    $this->startTime = $line['exp_start_time'];
    $this->endTime = $line['exp_end_time'];
    $this->userGroup = $line['exp_user_unique_id'];
    $this->visibility = $line['exp_visibility'];
    $this->expUserEmail = $line['exp_user_email'];
    $this->expRuns = $line['exp_runs'];

    //get the sensor ndoes which are used for the experiment
    $query2 = "SELECT * FROM experiment_network WHERE exp_id='" . $this->expID . "';";
    $result2 = mysql_query($query2) or die("Request for experiment_info failed: " . mysql_error());
    while ($line2 = mysql_fetch_assoc($result2))
    {
      //adds sensor node object to the experiment network object
      $this->network->addSensornodeFromDB($line2['node_urn']);
    }
    ksort($this->network->sensornodes);
    //adds all Sn-SN connections between the sensor nodes of the network
    $this->network->addAllSnSnConnections();
  }
  
  //***************************************************************************
  
  public function getSensorNodesOutputFromDB()
  {
    $resultArray = array();
    $snNetwork = $this->network->sensornodes;
    
    foreach($snNetwork as $snID)
    {
      $snid = $snid = "sn" . $snID->id;
      $snID->getOutputFromDB_Number($this->lines_gui, $this->expID);
      //$resultArray[$snid] = $snID->output;
    }
    //return $resultArray;
  }
  
  
  //***************************************************************************
  
  public function getExpControlOutput($exp_id)
  {
    $resultString = "";
    //get the sensor ndoes which are used for the experiment
    $query = "SELECT * FROM experimentcontroller_output WHERE exp_id='" . $exp_id ."' ORDER by rowindex ASC";
    $result = mysql_query($query)
      or die("Request for experimentcontroller_output failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($result))
    {
      $resultString = $resultString . $line['time'] . ": " . $line['line'] . "<br/>\n";
    }
    return $resultString;
  }
  
  //***************************************************************************
  
  public function getAllSensorNodeConnections()
  {
    $resultString = "";
    //get all connections between sensornodes
    $query = "SELECT * FROM sensornode_network";
    $result = mysql_query($query)
      or die("Request failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($result))
    {
      $resultString = $resultString . $line['node_urn'] . "->" . $line['node_urn_neighbor'] . "(" . $line['ETX'] . ")" . "<br>";
    }
    return $resultString;
  }

  //***************************************************************************  
  
}
  
?>
