<?php
  $config = array();
  $config_files[] = "/etc/TARWIS.conf";
  $config_files[] = "/etc/RS.conf";
  $config_files[] = "/etc/SNA.conf";
  $comment = "#";

  foreach($config_files as $config_file)
  {
    $fp = fopen($config_file, "r");
    if(empty($fp))
    {
      echo "<strong>Error:</strong> Configuration file could not find (should e.g.: \"/etc/TARWIS.conf\")!<br/>";
      exit;
    }
    while (!feof($fp))
    {
      $line = trim(fgets($fp));
      $divide = explode("#", $line);
      $line2 = trim($divide[0]);
      if(!empty($line2))
      {
        $pieces = explode("=", $line2);
        $option = trim($pieces[0]);
        $value = trim($pieces[1]);
        $config[$option] = $value;
      }
    }
    fclose($fp);
  }
  
  $mapFileName = $config['MAP_PATH'] . "/" . $config['MAP_FILE_NAME'];
  $mapSize = getimagesize($mapFileName);
  $config['MAP_IMG_WIDTH'] = $mapSize[0];
  $config['MAP_IMG_HEIGHT'] = $mapSize[1];
?>