<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: WebCTAS_Constants.inc,v 1.6 2004/02/24 15:28:58 vlry Exp $
 */
/* ****************************************************************** */

/**
* This file defines common constants for the WebCT Automatic
* signon package.
*
* @version $Revision: 1.6 $
* @package WebCTAPI
*/

/**
*/

// parameter names for parameters which are used in 
// the automatic signon request. Note: parameter names
// are case sensitive ! Using TIME STAMP instead of
// Time Stamp will result in an error (missing parameter).
// Also, note that the parameter for passing the Message
// Authentication Code is MAC and not AUTH as in the IMS
// API.
//
define('WEBCT_AS_PARAM_WUUI',       "WUUI");
define('WEBCT_AS_PARAM_TIMESTAMP',  "Time Stamp");
define('WEBCT_AS_PARAM_URL',        "URL");
define('WEBCT_AS_PARAM_IMS_ID',     "IMS id");
define('WEBCT_AS_PARAM_IMS_SOURCE', "IMS source");
define('WEBCT_AS_PARAM_MAC',        "MAC");

?>
