#!/usr/bin/env ruby
require 'ControllerServiceDriver.rb'

endpoint_url = ARGV.shift
obj = Controller.new(endpoint_url)

# run ruby with -d to see SOAP wiredumps.
obj.wiredump_dev = STDERR if $DEBUG

# SYNOPSIS
#   receive(parameters)
#
# ARGS
#   parameters      Receive - {urn:ControllerService}receive
#
# RETURNS
#   N/A
#
parameters = nil
puts obj.receive(parameters)

# SYNOPSIS
#   receiveStatus(parameters)
#
# ARGS
#   parameters      ReceiveStatus - {urn:ControllerService}receiveStatus
#
# RETURNS
#   N/A
#
parameters = nil
puts obj.receiveStatus(parameters)

# SYNOPSIS
#   receiveNotification(parameters)
#
# ARGS
#   parameters      ReceiveNotification - {urn:ControllerService}receiveNotification
#
# RETURNS
#   N/A
#
parameters = nil
puts obj.receiveNotification(parameters)

# SYNOPSIS
#   experimentEnded(parameters)
#
# ARGS
#   parameters      ExperimentEnded - {urn:ControllerService}experimentEnded
#
# RETURNS
#   N/A
#
parameters = nil
puts obj.experimentEnded(parameters)


