<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
    include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
	include '../include/menue.php';
	include 'expSetupMenue.php';
?>
</div>
<!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>
<?php
	require_once('../include/configurations.php');
	require_once("../include/classes.inc.php");
	require_once("../include/functions.php");

	//select DB
	Db::getInstance($config)->selectDB();
?> 
<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='expSetupSelInfoBox' class='infoBox'>
	<div id='expSetupSelInfoText' class='infoText'>
	<?php
		if(checkAccessRights($_SERVER['personUniqueID'], "viewNetwork"))
		{
			echo "<p><p><strong>Finished Experiments:</strong> You can find your past experiments and public experiments. Further you can download the results as zip file.</p>";
		}
		else
		{
			echo "<p><font color='#FF000'>" . "<strong>Error:</strong> You are not allowed to view experiments on the testbed and download their results!" . "</font></p>";
			exit;
		}
	?>
	</div>
<div id='expSetupSelCrossLine' class='crossLine'>&nbsp;</div>

</div>
<!-- end div container 'infoBox' --> <!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='expObservContentBox' class='contentBox'>
<?php

# echo "<pre>";
# print_r($_POST);
# echo "</pre>";

if (strlen(strstr($_POST['delete'],"Delete"))>0)
{
	$res = Db::getInstance($config)->deleteExperiment($_POST['exp_id']);
}
else if (strlen(strstr($_POST['deleteAllOwnExpiredExperiments'],"Delete all"))>0)
{
    $max = count($_POST);
    for($i=0; $i<$max; $i++){
        $label = "ownExperiments_" . $i;
        if(!empty($_POST[$label])) {
            $res = Db::getInstance($config)->deleteExperiment($_POST[$label]);
        }
    }
}

$pubExperiments = array_reverse(Db::getInstance($config)->getAllPublicExperimentConfigurations());
$ownExperiments = array_reverse(Db::getInstance($config)->getAllOwnOldExperimentConfigurations($_SERVER['personUniqueID']));

echo "<br/><strong><font size='4'>My private experiments: </font></strong><br/><br/>";
if(count($ownExperiments) == 0)
{
	echo "<br/><i>no <strong>private</strong> experiments saved</i><br/>";
	echo "<br/>";
} 
else 
{
    $ownExperimentIds = array();
    echo "<table style='border: 1px solid black; margin-bottom:10px;'>\n";
    echo "<colgroup>\n";
    echo "<col width='350'/>\n";
    echo "<col width='350'/>\n";
    echo "</colgroup>\n";
    echo "<tr>";
    echo "<td><strong>Delete all your Experiments</strong></td>\n";
    echo "<td align='right'>";
    echo "<form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='ownExpDeleteForm' action='expSetupFinExp.php' method='POST'>";
    echo "<input type='submit' id='deleteAllOwnExpiredExperiments' name='deleteAllOwnExpiredExperiments' value='Delete all Experiment Definition &amp; Results'/>";
    $i = 0;
    foreach($ownExperiments as $ownExp)
    {
        echo "<input name='ownExperiments_" . $i . "' type='hidden' value='" .$ownExp['exp_id'] . "'/>";
        $i++;
    }
    echo "</form>";
    echo "</td>";
    echo "</tr>"; 
    echo "</table>";
    
    $lastExp;
    // OWN PRIVATE EXPERIMENTS REPOSITORY
    foreach($ownExperiments as $ownExp)
    {
    	$_POST['exp_id'] = $ownExp['exp_id'];
    	// set a html anchor!
        echo "\n\n<a name=own" . $ownExp['exp_id'] . "></a>\n";
    	echo "<table style='border: 1px solid black; margin-bottom:10px;'>\n";
    	echo "<colgroup>\n";
    	echo "<col width='200'/>\n";
    	echo "<col width='500'/>\n";
    	echo "</colgroup>\n";
    	echo "<tr>";
    	echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>".$ownExp['exp_user_unique_id']." (".$ownExp['exp_user_email'].")</td>\n";
    	echo "</tr>";
    	echo "<tr>";
    	echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'>" . $ownExp['exp_id'] . "</td>\n";
    	echo "</tr>";
    	echo "<tr>";
    	echo "<td><strong>Name:       </strong></td>" . "<td bgcolor='#F2F2F2'>" . $ownExp['exp_name'] . "</td>\n";
    	echo "</tr>";
    	echo "<tr>";
    	echo "<td style='vertical-align:top'><strong>Description: </strong></td>\n";
    	if(strlen($ownExp['exp_description']) == 0)
    	{
    		echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>\n";
    	}
    	else
    	{
    		echo "<td bgcolor='#F2F2F2'>" . $ownExp['exp_description'] . "</td>\n";
    	}
    	echo "</tr>";
    	echo "<tr>";
    	echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $ownExp['exp_start_time'] . "</td>\n";
    	echo "</tr>";
    	echo "<tr>";
    	echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $ownExp['exp_end_time'] . "</td>\n";
    	echo "</tr>";
    	echo "<tr>";
    	echo "<td><strong>Results: </strong></td>\n";
    	echo "<td><table border='0' width='100%' cellspacing='0' cellpadding='0'>\n";
    	echo "<tr><td width='50%'><form STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='ownExpDownloadForm' action='expSetupFinExpDownload.php' method='POST'>\n";
    	echo "<input type='submit' id='download' name='download' value='Download'/>\n";
    	echo "<input name='exp_id' type='hidden' value='" . $ownExp['exp_id'] . "'/>\n";
    	echo "</form></td><td width='50%'>";
    	echo "<form  STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='ownExpDeleteForm'";
    	if(strlen($lastExp)>0) {
    	   echo " action='expSetupFinExp.php#own" . $lastExp . "' method='POST'>";
    	}
    	else {
    	   echo " action='expSetupFinExp.php' method='POST'>";	
    	}
    	echo "<input type='submit' id='delete' name='delete' value='Delete Experiment Definition &amp; Results'/>";
    	echo "<input name='exp_id' type='hidden' value='" . $ownExp['exp_id'] . "'/></form>";
    	echo "</td></tr></table></td>\n";
    	echo "</tr></table>\n\n";
    	$lastExp = $ownExp['exp_id'];
    }

}
// PUBLIC EXPERIMENTS REPOSITORY


echo "<br/><strong><font size='4'>Public experiments: </font></strong><br/><br/>";
if(count($pubExperiments) == 0)
{
	echo "<br/><i>no <strong>public</strong> experiments saved</i><br/>";
}

foreach($pubExperiments as $pubExp)
{
	$_POST['exp_id'] = $pubExp['exp_id'];
	echo "\n\n<a name=pub" . $pubExp['exp_id'] . "></a>\n";
	echo "<table style='border: 1px solid black; margin-bottom:10px;'>\n";
	echo "<colgroup>\n";
	echo "<col width='200'/>\n";
	echo "<col width='500'/>\n";
	echo "</colgroup>\n";
	echo "<tr>";
	echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>".$pubExp['exp_user_unique_id']." (".$pubExp['exp_user_email'].")</td>\n";
	echo "</tr>";
	echo "<tr>";
	echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'>" . $pubExp['exp_id'] . "</td>\n";
	echo "</tr>";
	echo "<tr>";
	echo "<td><strong>Name:       </strong></td>" . "<td bgcolor='#F2F2F2'>" . $pubExp['exp_name'] . "</td>\n";
	echo "</tr>";
	echo "<tr>";
	echo "<td style='vertical-align:top'><strong>Description: </strong></td>\n";
	if(strlen($pubExp['exp_description']) == 0)
	{
		echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>\n";
	}
	else
	{
		echo "<td bgcolor='#F2F2F2'>" . $pubExp['exp_description'] . "</td>\n";
	}
	echo "</tr>";
	echo "<tr>";
	echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $pubExp['exp_start_time'] . "</td>\n";
	echo "</tr>";
	echo "<tr>";
	echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $pubExp['exp_end_time'] . "</td>\n";
	echo "</tr>";
	echo "<tr>";
	echo "<td><strong>Results: </strong></td>\n";
	echo "<td><table border='0' width='100%' cellspacing='0' cellpadding='0'>\n";
	echo "<tr><td width='50%'><form STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='ownExpDownloadForm' action='expSetupFinExpDownload.php' method='POST'>\n";
	echo "<input type='submit' id='download' name='download' value='Download'/><input name='exp_id' type='hidden' value='" . $pubExp['exp_id'] . "'/>\n";
	echo "</form></td><td width='50%'></form></td></tr></table>\n";
	echo "</td>\n";
	echo "</tr>";
	echo "</table>\n\n";
}

echo "<br/>";
echo "<br/>";

######################################################################################
#  ONLY FOR THE TESTBED MAINTAINER VIEW: GIVE THE OPTION TO DELETE PAST EXPERIMENTS  #
######################################################################################

if(checkAccessRights($_SERVER['personUniqueID'], "maintainReservation") || checkAccessRights($_SERVER['personUniqueID'], "maintainTestbed")) {

    $otherExperiments = array_reverse(Db::getInstance($config)->getAllOtherUsersExperimentConfigurations($_SERVER['personUniqueID']));

    echo "<br/><strong><font size='4'>Other Users Past Experiments:</font></strong><br/>";
    echo "<br/><strong>(only accessible as TARWIS Administrator)</strong><br/><br/>";
    if(count($otherExperiments) == 0)
    {
        echo "<br/><i>no <strong>other users past experiments</strong> experiments saved</i><br/>";
        echo "<br/>";
    }

    // OWN PRIVATE EXPERIMENTS REPOSITORY
    foreach($otherExperiments as $otherExperiment)
    {
        $_POST['exp_id'] = $otherExperiment['exp_id'];
        // set a html anchor!
        echo "\n\n<a name=own" . $otherExperiment['exp_id'] . "></a>\n";
        echo "<table style='border: 1px solid black; margin-bottom:10px;'>\n";
        echo "<colgroup>\n";
        echo "<col width='200'/>\n";
        echo "<col width='500'/>\n";
        echo "</colgroup>\n";
        echo "<tr>";
        echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>".$otherExperiment['exp_user_unique_id']." (".$otherExperiment['exp_user_email'].")</td>\n";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'>" . $otherExperiment['exp_id'] . "</td>\n";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>Name:       </strong></td>" . "<td bgcolor='#F2F2F2'>" . $otherExperiment['exp_name'] . "</td>\n";
        echo "</tr>";
        echo "<tr>";
        echo "<td style='vertical-align:top'><strong>Description: </strong></td>\n";
        if(strlen($otherExperiment['exp_description']) == 0)
        {
            echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>\n";
        }
        else
        {
            echo "<td bgcolor='#F2F2F2'>" . $otherExperiment['exp_description'] . "</td>\n";
        }
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $otherExperiment['exp_start_time'] . "</td>\n";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $otherExperiment['exp_end_time'] . "</td>\n";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>Results: </strong></td>\n";
        echo "<td><table border='0' width='100%' cellspacing='0' cellpadding='0'>\n";
        echo "<tr><td width='50%'><form STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='ownExpDownloadForm' action='expSetupFinExpDownload.php' method='POST'>\n";
        echo "<input type='submit' id='download' name='download' value='Download'/>\n";
        echo "<input name='exp_id' type='hidden' value='" . $otherExperiment['exp_id'] . "'/>\n";
        echo "</form></td><td width='50%'>";
        echo "<form  STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='ownExpDeleteForm'";
        if(strlen($lastExp)>0) {
            echo " action='expSetupFinExp.php#own" . $lastExp . "' method='POST'>";
        }
        else {
            echo " action='expSetupFinExp.php' method='POST'>";
        }
        echo "<input type='submit' id='delete' name='delete' value='Delete Experiment Definition &amp; Results'/>";
        echo "<input name='exp_id' type='hidden' value='" . $otherExperiment['exp_id'] . "'/></form>";
        echo "</td></tr></table></td>\n";
        echo "</tr></table>\n\n";
        $lastExp = $otherExperiment['exp_id'];
    }
}
?>
</div>
<!-- end div container 'contentBox' --> <!-- ********************************************************************** -->


</div>
<!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
</body>
</html>
<!-- ********************************************************************** -->
