<?php
/**
 * Bug fixes for PHP prior to release 4.2. 
 *
 * @author Valery Tschopp <tschopp@switch.ch>
 * @version $Revision: 1.2 $
 *
 * @package Library
 */
/** 
 * Defines the function is_a(...) if not existing.
 *
 * @param mixed $object The object to test.
 * @param string $className The classname.
 * @return boolean true iff $object is a instance of $classname or of one subclass.
 */
if (!function_exists('is_a')) {
  function is_a( $object, $className ) {
   return ((strtolower($className) == get_class($object))
         or (is_subclass_of($object, $className)));
  }
}

?>
