<?php
/*
* SNA-Portal mediates between one or more Authentication and Authorisation
* Infrastructures and non-AAI-enabled roles.
* Copyright (C) 2003 Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
* Copyright (C) 2004 SWITCH (http://www.switch.ch)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
* $Id: WebCTVistaIMS.inc,v 1.3 2004/05/19 13:41:43 vlry Exp $
*/
/**
* This is the common include file for the WebCTVistaIMS package. 
* Include (use require_once, not require or include !) this file at the 
* beginning of your PHP page in order to load the required constants, 
* classes and libraries.
*
* <b>Example</b>
* <pre>
*   // load the WebCTVistaIMS package
*   require_once("include/webct/WebCTVistaIMS.inc");
* </pre>
*
* @author Valery Tschopp - SWITCH
* @version $Revision: 1.3 $
*
* @package WebCTAPI
*/

// load unmodified classes
require_once("include/webct/WebCTIMS_API.class.inc");
require_once("include/webct/WebCTIMS_IMSDataObject.class.inc");
require_once("include/webct/WebCTIMS_Response.class.inc");

// load WebCT Vista specific classes
require_once("include/webct/WebCTVista.inc");
require_once("include/webct/WebCTVistaIMS_Constants.inc");
require_once("include/webct/WebCTVistaIMS_Request.inc");
require_once("include/webct/WebCTVistaIMS_IMSDataObjectNode.inc");
require_once("include/webct/WebCTVistaIMS_XMLWriter.inc");
require_once("include/webct/WebCTVistaIMS_SwitchAAIAdapting.inc");
?>
