#!/bin/bash

echo "#############################################################"
echo "This script sets up the SNA mysql database tables!           "
echo "This requires that you know your root mysql user password!!  "
echo "#############################################################"


cd /opt/sna-portal-1.0.5/db 

cat > createSNAPortalTable << EOF

DROP DATABASE IF EXISTS snaportal;

GRANT DELETE, INSERT, SELECT, UPDATE
      ON snaportal.*
      TO snaportal@localhost  IDENTIFIED BY 'wisebed';
QUIT

EOF


echo "ENTER THE ROOT MYSQL USER PASSWORD (SETTING UP SNA-MYSQL USER):"
mysqladmin -u root -p create snaportal

echo "ENTER THE ROOT MYSQL USER PASSWORD (DELETING PREVIOUS SNA-DATABASES, IF EXISTING):"
mysql -u root -p < createSNAPortalTable


rm -rf createSNAPortalTable

echo "ENTER THE ROOT MYSQL USER PASSWORD (LOADING SNA-PORTAL-DB's):"
mysql -u root -p --database=snaportal < sna-portal-db.sql
